"use strict";

var task = regeneratorRuntime.mark(function task(step, abort) {
  var disjoint_ret, disjoint_out, callback_ret, callback_out, parallel_arr_ret, parallel_arr_out, parallel_key_ret, parallel_key_out, k, subtask_ret, subtask, subtask_out, done, running, concurrency, run;
  return regeneratorRuntime.wrap(function task$(context$1$0) {
    while (1) switch (context$1$0.prev = context$1$0.next) {
      case 0:
        run = function run(_) {
          running += 1;
          assert(running <= concurrency);
          setTimeout(function ($) {
            running -= 1;
            counter("concurrent", _, null);
          });
        };

        disjoint_ret = {};
        setTimeout(function (_) {
          return counter("disjoint", step, null, disjoint_ret);
        });
        context$1$0.next = 5;
        return step;
      case 5:
        disjoint_out = context$1$0.sent;
        assert(disjoint_ret == disjoint_out);

        setTimeout(function (_) {
          return counter("disjoint", step, null, disjoint_ret);
        });
        context$1$0.next = 10;
        return step;
      case 10:
        disjoint_out = context$1$0.sent;
        assert(disjoint_ret == disjoint_out);

        callback_ret = {};
        context$1$0.next = 15;
        return function (_) {
          return setTimeout(function ($) {
            return counter("callback", _, null, callback_ret);
          });
        };
      case 15:
        callback_out = context$1$0.sent;
        assert(callback_out == callback_ret);


        parallel_arr_ret = [{}, {}];
        context$1$0.next = 20;
        return [function (_) {
          return setTimeout(function ($) {
            return counter("parallel_arr", _, null, parallel_arr_ret[0]);
          });
        }, function (_) {
          return setTimeout(function ($) {
            return counter("parallel_arr", _, null, parallel_arr_ret[1]);
          });
        }];
      case 20:
        parallel_arr_out = context$1$0.sent;
        assert(parallel_arr_ret.length == parallel_arr_out.length);
        parallel_arr_out.forEach(function (v, i) {
          assert(v == parallel_arr_ret[i]);
        });

        parallel_key_ret = {
          a: {},
          b: {}
        };
        context$1$0.next = 26;
        return {
          a: function (_) {
            return setTimeout(function ($) {
              return counter("parallel_key", _, null, parallel_key_ret.a);
            });
          },
          b: function (_) {
            return setTimeout(function ($) {
              return counter("parallel_key", _, null, parallel_key_ret.b);
            });
          },
          c: function (_) {
            return setTimeout(function ($) {
              return counter("parallel_key", _, null, parallel_key_ret.c);
            });
          }
        };
      case 26:
        parallel_key_out = context$1$0.sent;
        for (k in parallel_key_ret) {
          assert(parallel_key_ret[k] == parallel_key_out[k], k + " to be the same");
        }
        // need to check both (easier than checking keys  are the same in case of prototype changes)
        for (k in parallel_key_out) {
          assert(parallel_key_ret[k] == parallel_key_out[k], k + " to be the same");
        }

        subtask_ret = {};
        subtask = regeneratorRuntime.mark(function callee$1$0() {
          return regeneratorRuntime.wrap(function callee$1$0$(context$2$0) {
            while (1) switch (context$2$0.prev = context$2$0.next) {
              case 0:
                context$2$0.next = 2;
                return function (_) {
                  return setTimeout(function ($) {
                    return counter("subtask", _, null);
                  });
                };
              case 2:
                context$2$0.next = 4;
                return function (_) {
                  return setTimeout(function ($) {
                    return counter("subtask", _, null);
                  });
                };
              case 4:
                context$2$0.next = 6;
                return function (_) {
                  return setTimeout(function ($) {
                    return counter("subtask", _, null);
                  });
                };
              case 6:
                context$2$0.next = 8;
                return function (_) {
                  return setTimeout(function ($) {
                    return counter("subtask", _, null);
                  });
                };
              case 8:
                return context$2$0.abrupt("return", subtask_ret);
              case 9:
              case "end":
                return context$2$0.stop();
            }
          }, callee$1$0, this);
        });
        context$1$0.next = 33;
        return subtask();
      case 33:
        subtask_out = context$1$0.sent;
        assert(subtask_out == subtask_ret);

        context$1$0.next = 37;
        return function (_) {
          try {
            step();
          } catch (e) {
            assert(e);
            counter("guard", _);
            return;
          }
          assert(false);
        };
      case 37:
        context$1$0.next = 39;
        return null;
      case 39:
        context$1$0.next = 41;
        return undefined;
      case 41:
        done = 0;
        context$1$0.next = 44;
        return [function (_) {
          done += 1;_();
        }, function (_) {
          done += 1;_();
        }];
      case 44:
        assert(done == 2);

        running = 0;
        concurrency = 2;
        context$1$0.next = 49;
        return runner.concurrent(concurrency, [run, run, run, run, run, run, run, run, run, run, run]);
      case 49:
        return context$1$0.abrupt("return", ret);
      case 50:
      case "end":
        return context$1$0.stop();
    }
  }, task, this);
});

var runner = require("../../");
var assert = require("assert");

var counted = {};
function counter(k, fn) {
  for (var _len = arguments.length, prefixargs = Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
    prefixargs[_key - 2] = arguments[_key];
  }

  counted[k] = counted[k] || 0;
  counted[k]++;
  console.log(k);
  return fn.apply(this, prefixargs);
}

var ret;
var expected = {
  disjoint: 2,
  callback: 1,
  parallel_arr: 2,
  parallel_key: 3,
  subtask: 4,
  guard: 1,
  concurrent: 11
};
var ran = 0;
process.on("exit", function (_) {
  return assert(ran == 2);
}, "the test ran");
// make it run!
runner(task, function (err, val) {
  ran += 1;
  assert(!err, "there is not an error: " + err);
  assert(val == ret, "the return value is the same reference");
  var expectedKeys = Object.keys(expected).sort();
  var countedKeys = Object.keys(counted).sort();
  assert(expectedKeys.length == countedKeys.length, "the keys have the same length for expected and counted");
  assert(JSON.stringify(expectedKeys) == JSON.stringify(countedKeys), "the keys for expected and counted are the same values");
  expectedKeys.forEach(function (k) {
    assert(expected[k] == counted[k], "the " + k + " key is the same value for expected and counted");
  });
  countedKeys.forEach(function (k) {
    assert(expected[k] == counted[k], "the " + k + " key is the same value for expected and counted");
  });
});

var abort_ret = {};
runner(regeneratorRuntime.mark(function abort_task(step, abort) {
  var done;
  return regeneratorRuntime.wrap(function abort_task$(context$1$0) {
    while (1) switch (context$1$0.prev = context$1$0.next) {
      case 0:
        try {
          abort();
          assert(false, "abort without a value should throw");
        } catch (e) {
          // haha need a value
          assert(e, "aborting without a value should throw");
        }
        done = false;
        setImmediate(function (_) {
          done = true;
          abort(abort_ret);
        });
        setImmediate(function (_) {
          assert(done, "we should be done already");
          try {
            // aborting when we are done is not an error
            abort(abort_ret);
          } catch (e) {
            assert(false, "multiple aborts are allowed");
          }
        });
        context$1$0.next = 6;
        return function (_) {
          return setImmediate(function ($) {
            try {
              _();
            } catch (e) {
              assert(e, "continuing after an abort is not possible");
            }
          });
        };
      case 6:
      case "end":
        return context$1$0.stop();
    }
  }, abort_task, this);
}), function (err) {
  ran += 1;
  assert(err == abort_ret, "aborting causes an error");
});
// check the guard


// test skipping


// test timing consistency
// test concurrency runner
//# sourceMappingURL=index.js.map